<div class="container">

<?php
session_start(); if (!$_SESSION['user']) { die('not authorized'); }

require_once "config.php";
require_once "../adam/wrapper.php";

loadAllCfg();
tryConnect();

$action = @$_GET['action'];
$assistantId = @$_GET['assistantId'];

$ip = getClientIP();

if ($action == 'new') {
?>
  <script>
  $.ajax({
    url: 'createnewassistant.php',
    type: 'POST',
    success: function(response) {
      window.location.href = '?pageid=userpages_assistantFactory'      
    },
    error: function() {
      alert('Cannot create - retry')
      window.location.href = '?pageid=userpages_assistantFactory'      
    }
  });
  </script>
<?php
}

if ($action == 'clone') {
?>
  <script>
  $.ajax({
    url: 'cloneassistant.php?id=<?=$assistantId?>',
    type: 'POST',
    success: function(response) {
      window.location.href = '?pageid=userpages_assistantFactory'      
    },
    error: function() {
      alert('Cannot clone - retry')
      window.location.href = '?pageid=userpages_assistantFactory'      
    }
  });
  </script>
<?php
}
?>

<?php
  if ($action == '' || $action == 'chats') {
?>    
    <script>
    function goToBotUrl(id, threadId, continueChat) {
      var url = new URL(window.location.href);
      var pathname = url.pathname;

      // Remove any file name if present
      pathname = pathname.replace(/\/[^\/]*$/, '');

      // Remove the last segment of the path to go one level up
      pathname = pathname.replace(/\/[^\/]+\/?$/, '/');

      // Construct the new base URL
      var baseUrl = url.origin + pathname;
      continueUrl = '';
      if (continueChat)
        continueUrl = '&continue=1';
      window.location.href = baseUrl + id + '?threadId='+threadId+ continueUrl;
    }
  </script>
<?php
  }
?>

<?php
if ($action == '') {
?>
  <a href="?pageid=userpages_assistantFactory&action=new" class="btn btn-block btn-primary" style="padding: 1.5rem 2rem; font-size: 1.25rem; border-radius: .3rem;">
    <i class='fas fa-robot'></i>&nbsp;&nbsp;Create a new assistant
  </a>
  <br><br>

<?php
  echo "<div class=container>";
  $r = listAssistants($apiKey);
  echo "<div class=row>";
  for($i=0; $i<count($r['data']); ++$i) {
    echo "<div class='col-md-4'>";
    printAssistant($r['data'][$i]);
    echo "</div>";
  }
  echo "</div>";
  echo "</div>";
}

if ($action == 'delete') {
  // delete it from OpenAI
  $r = deleteAssistant($apiKey, $assistantId);
  // delete it from the DB
  $conn->query("DELETE FROM assistants WHERE assistantId='$assistantId'");
  // delete the folder for the iframe
  $currentDirectory = getcwd();
  $parentDirectory = dirname($currentDirectory);
  @unlink($parentDirectory."/".$assistantId."/chatgpt.php");
  @unlink($parentDirectory."/".$assistantId."/chatjs.php");
  @unlink($parentDirectory."/".$assistantId."/wrapper.php");
  @unlink($parentDirectory."/".$assistantId."/index.php");
  @unlink($parentDirectory."/".$assistantId."/error_log");
  @unlink($parentDirectory."/".$assistantId."/runs.txt");
  @unlink($parentDirectory."/".$assistantId."/debug_log.txt");
  @rmdir($parentDirectory."/".$assistantId);
?>
  <script>
    window.location.href = '?pageid=userpages_assistantFactory'
  </script>
<?php
  exit;
}

if ($action == 'chats') {
  $aboAssistant = zbSQLAssoc("SELECT * FROM assistants WHERE assistantId='$assistantId'");
  $a = getAssistant($apiKey, $assistantId);
  $threads = zbSQL("SELECT COUNT(*) FROM threads WHERE assistantId='$assistantId'");
  echo "<h1>{$a['name']}</h1>";
  echo "<h2>{$a['description']}</h2>";
  $s = "
    SELECT r.*
    FROM `runs` r
    INNER JOIN (
      SELECT MAX(`id`) AS max_id, `threadId`
      FROM `runs`
      WHERE `assistantId` = '$assistantId'
      GROUP BY `threadId`
    ) grouped_runs ON r.`id` = grouped_runs.max_id
    WHERE r.`assistantId` = '$assistantId' AND totalCost>0
  ";
  $r = zbSQLAssocMulti($s);
  if (count($r) == 0) {
    echo "No conversations found<br><br>";
  } else {
?>  
  <table class='table table-responsive'>
    <thead>
      <th>Raw Chat</th>
      <th>Pretty Chat</th>
      <th>CSV/Excel</th>
      <th>PDF</th>
      <th>Cost (/1M $)</th>
      <th>Continue</th>
      <th>Thread ID</th>
      <th><i class='fas fa-trash'></i></th>
    </thead>
<?php
  $totalCost = 0;
  for($i=0; $i<count($r); ++$i) {
    $id = $r[$i]['threadId'];
?>    
    <tr id="row_<?=$id?>">
      <td class="text-center">
        <a target=_blank href='getrawfromthread.php?id=<?=$id?>'><i class='fas fa-file'></i></a>
      </td>    
      <td class="text-center">
        <a target=_blank href='getchatsfromthread.php?id=<?=$id?>'><i class='fas fa-eye'></i></a>
      </td>    
      <td class="text-center">
        <a target=_blank href='getcsvfromthread.php?id=<?=$id?>'><i class='fas fa-download'></i></a>
      </td>
      <td class="text-center">
        <a target=_blank href='getpdffromthread.php?id=<?=$id?>'><i onclick='getCSVFromThread(<?=$id?>)' class='fas fa-file-pdf'></i></a>
      </td>
      <td>
        <?=$r[$i]['totalCost']?>
      </td>
      <td>
        <a target=_blank href='#'><i onclick='goToBotUrl("<?=$assistantId?>", "<?=$id?>", true)' class='fas fa-comments'></i></a>
      </td>
      <td>
        <?=$id?>
      </td>
      <td>
        <i style='color:red; cursor:pointer;' onclick='deleteThread("<?=$id?>")' class='fas fa-trash'></i>
      </td>
    </tr>
<?php    
    $totalCost += $r[$i]['totalCost'];
  }
  echo "<tfoot><td></td><td></td><td></td><td></td><td><span style='color:red'><b>".sprintf("%.8f", $totalCost/1000000)." </b></span>$</td><td></td></tfoot>";
  echo "</table>";
?>
  <script>
    function deleteThread(id) {
      loading('row_'+id)
      $.ajax({
        url: 'deletethread.php?id='+id,
        type: 'POST',
        success: function(response) {
          document.getElementById('row_'+id).style.display = 'none'
        },
        error: function() {
          alert('Cannot delete - retry')
        }
      });
    }
    function getChatsFromThread(id) {
      loading(id)
      $.ajax({
        url: 'getchatsfromthread.php?id='+id,  // Path to your PHP file
        type: 'GET',           // Method type GET/POST
        success: function(response) {
          document.getElementById(id).innerHTML = response;  // Fill div with result
        },
        error: function() {
          $(`#${id}`).html('Error loading information');  // Error handling
        }
      });
    }
  </script>
<?php
  }
  if ($aboAssistant['locked'] == 'N') {
?>
    <button class='btn btn-danger'><i class='fas fa-trash'></i> Delete it!</button> 
<?php  
  } else {
?>
  In order to delete this bot, you must unlock it first - to avoid deleting it by mistake
<?php    
  }
}

if ($action == 'view') {
  $a = getAssistant($apiKey, $assistantId);
?>  
  <div class="container">
    <h1>View Bot</h1>
    <form>
      <input type="hidden" name="action" value="view">
      <div class="row">
        <div class="col-6">
          <label class="form-control">Bot ID</label>
        </div>
        <div class="col-6">
          <input disabled class="form-control" type="text" value="<?=$a['id']?>">
        </div>
      </div>
      <div class="row">
        <div class="col-6">
          <label class="form-control">Bot Name</label>
        </div>
        <div class="col-6">
          <input disabled class="form-control" type="text" value="<?=$a['name']?>">
        </div>
      </div>
      <div class="row">
        <div class="col-6">
          <label class="form-control">Bot Description</label>
        </div>
        <div class="col-6">
          <input disabled class="form-control" type="text" value="<?=$a['description']?>">
        </div>
      </div>
      <div class="row">
        <div class="col-6">
          <label class="form-control">Bot Creation Date</label>
        </div>
        <div class="col-6">
          <input disabled class="form-control" type="text" value="<?=date("D, M jS h:iA", $a['created_at'])?>">
        </div>
      </div>
      <div class="row">
        <div class="col-6">
          <label class="form-control">Bot Model</label>
        </div>
        <div class="col-6">
          <input disabled class="form-control" type="text" value="<?=$a['model']?>">
        </div>
      </div>
      <div class="row">
        <div class="col-12">
          <label class="form-control text-center">Instructions</label>
        </div>
        <div class="col-12">
          <textarea rows=10 disabled class="form-control""><?=htmlentities($a['instructions'])?></textarea>
        </div>
      </div>
      <br><br>
      <a href='?pageid=userpages_assistantFactory&assistantId=<?=$a['id']?>&action=edit' class="btn btn-primary btn-block"><i class='fas fa-edit'></i> Edit</a>
      </form>
    </div>
<?php
}

if ($action == 'edit') {
  $a = getAssistant($apiKey, $assistantId);
?>  
  <div class="container">
    <h1>Edit Bot</h1>
    <form id="assistant">
      <input type="hidden" name="assistantId" id="assistantId" value="<?=$assistantId?>">
      <div class="row">
        <div class="col-6">
          <label class="form-control">Bot ID</label>
        </div>
        <div class="col-6">
          <input disabled class="form-control" type="text" name=assistantId id=assistantId value="<?=$a['id']?>">
        </div>
      </div>
      <div class="row">
        <div class="col-6">
          <label class="form-control">Bot Name</label>
        </div>
        <div class="col-6">
          <input class="form-control" type="text" name=name id=name value="<?=htmlentities($a['name'])?>">
        </div>
      </div>
      <div class="row">
        <div class="col-6">
          <label class="form-control">Bot Description</label>
        </div>
        <div class="col-6">
          <input class="form-control" type="text" name=description id=description value="<?=htmlentities($a['description'])?>">
        </div>
      </div>
      <div class="row">
        <div class="col-6">
          <label class="form-control">Bot Creation Date</label>
        </div>
        <div class="col-6">
          <input disabled class="form-control" type="text" value="<?=date("D, M jS h:iA", $a['created_at'])?>">
        </div>
      </div>
      <div class="row">
        <div class="col-6">
          <label class="form-control">Bot Model</label>
        </div>
        <div class="col-6">
<?php
  $selected1 = $selected2 = $selected3 = '';
  if ($a['model'] == 'gpt-4o-mini')
    $selected1 = 'selected';
  if ($a['model'] == 'gpt-4o')
    $selected2 = 'selected';
  if ($a['model'] == 'gpt-4')
    $selected3 = 'selected';

?>
          <select class="form-control" name=model id=model >
            <option <?=$selected1?>>gpt-4o-mini</option>
            <option <?=$selected2?>>gpt-4o</option>
            <option <?=$selected3?>>gpt-4</option>
          </select>
        </div>
      </div>
      <div class="row">
        <div class="col-12">
          <label class="form-control text-center">Instructions</label>
        </div>
        <div class="col-12">
          <textarea name=instructions id=instructions rows=10 class="form-control""><?=htmlentities($a['instructions'])?></textarea>
        </div>
      </div>
      <br><br>
      <a onclick="modifyAssistant()" class="btn btn-primary btn-block"><i class='fas fa-save'></i> Save</a>
      </form>
    </div>

    <script>
      function modifyAssistant() {
        // Serialize the form data.
        var formData = $('#assistant').serialize();

        // AJAX POST request
        $.ajax({
            url: 'modifyassistant.php',
            type: 'POST',
            data: formData,
            success: function(response) {
              // Handle success
              console.log('Success:', response);
              alert('Updated successfully!');
            },
            error: function(xhr, status, error) {
              // Handle errors
              console.log('Error:', xhr.responseText);
              alert('Error while saving data, try again!');
            }
          });
      }
    </script>
<?php
}

function printAssistant($a) {
  $abo = zbSQLAssoc("SELECT * FROM assistants WHERE assistantId='{$a['id']}'");
  $len = mb_strlen($a['instructions']);
  $color = 'bg-danger';
  if ($len > 100) {
    $color = 'bg-success';
  }
?>
<div class="card card-widget widget-user-2">
  <div class="widget-user-header <?=$color?>">
    <div class="widget-user-image">
      <img class="img-circle elevation-2" src="../<?=$abo['assistantId']?>/logo.png" alt="Bot Avatar">
    </div>
    <h3 class="widget-user-username"><?=$a['name']?></h3>
    <h5 class="widget-user-desc"><?=$a['description']?></h5>
  </div>
  <div class="card-footer p-0">
    <ul class="nav flex-column">
      <li class="nav-item">
        <span class="nav-link">
          ID <span class="float-right badge bg-danger"><?=$a['id']?></span>
        </span>
      </li>
      <li class="nav-item">
        <span class="nav-link">
          Model <span class="float-right badge bg-primary"><?=$a['model']?></span>
        </span>
      </li>
      <li class="nav-item">
        <span class="nav-link">
          Instructions <span class="float-right badge bg-info"><?=formatBytes($len)?></span>
        </span>
      </li>
      <li class="nav-item">
        <span class="nav-link">
          Created on <span class="float-right badge bg-success"><?=date("D, M jS h:iA", $a['created_at'])?></span>
        </span>
      </li>
      <li class="nav-item">
        <span class="nav-link">
          <div class="row">
            <div class="col-2 text-center" style="color:blue">
              <a href='?pageid=userpages_assistantFactory&assistantId=<?=$a['id']?>&action=view'><i title='View' class="fas fa-eye"></i></a>
            </div>
            <div class="col-2 text-center" style="color:blue">
              <a href='?pageid=userpages_assistantFactory&assistantId=<?=$a['id']?>&action=edit'><i title='Edit' class="fas fa-edit"></i></a>
            </div>
<?php
  if (0) {
?>    
            <div class="col-2 text-center" style="color:yellow">
              <i title='Deploy' class="fas fa-rocket"></i>
            </div>
<?php
  } else {
?>                
            <div class="col-2 text-center">
              <a style="color:green" href='?pageid=userpages_assistantFactory&assistantId=<?=$a['id']?>&action=chats'>
                <i title='See the chats' class="fas fa-comments"></i>
              </a>
            </div>
<?php
  }
?>              
            <div class="col-2 text-center">
              <a style="color:green" href='?pageid=userpages_assistantFactory&assistantId=<?=$a['id']?>&action=clone'><i title='Clone' class="fas fa-copy"></i></a>
            </div>
            <div class="col-2 text-center">
              <a style="color:orange" href="#" target=_blank onclick="goToBotUrl('<?=$a['id']?>', 0, false)"><i title='Bot URL' class="fas fa-sun"></i></a>
            </div>
            <div class="col-2 text-center">
<?php
  if ($abo['locked'] == 'N') {
?>
              <a style="color:red" href='?pageid=userpages_assistantFactory&assistantId=<?=$a['id']?>&action=delete'><i title='Delete' class="fas fa-trash"></i></a>
<?php
  } else {
?>
              <a style="color:gray" href='#'><i title='Delete' class="fas fa-trash"></i></a>
<?php
  }            
?>  
            </div>
          </div>

        </span>
      </li>
    </ul>
  </div>
</div>
<?php
}
/*
// LIST ASSISTANTS 
$apiKey = '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';
$assistantId = 'asst_MPCeU9MP8BbPmqk2m07Hk45B';

$r = listAssistants($apiKey);
for($i=0; $i<count($r['data']); ++$i) {
  echo "Name: ".$r['data'][$i]['name']."<br>";
  echo "Id: ".$r['data'][$i]['id']."<br>";
  echo "Model: ".$r['data'][$i]['model']."<br>";
  echo "Description: ".$r['data'][$i]['description']."<br>";
  echo "Created at: ".$r['data'][$i]['created_at']." = ".date("D, M jS h:iA", $r['data'][$i]['created_at']);"<br>";
  echo "<hr>";
}

*/
?>

</div>