<?php
session_start();

require_once "wrapper.php";

$conn = new mysqli($SERVER_NAME, $DB_USERNAME, $DB_PASSWORD, $DB_NAME);
$conn->set_charset('utf8');
mb_internal_encoding("UTF-8");

$s = "SELECT * FROM assistants WHERE assistantId='$assistantId'";
error_log($s);
$a = zbSQLAssoc($s);

?>
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="UTF-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
<?php
  if ($a['showMath'] == 'Y') {
?>
  <script src="https://cdnjs.cloudflare.com/ajax/libs/mathjax/3.2.0/es5/tex-mml-chtml.js" crossorigin="anonymous"></script>
<?php
  }
?>  
  <title><?=htmlentities($a['name'])?></title>
  <link rel="shortcut icon" href="logo.png" type="image/x-icon">
  <link href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css" rel="stylesheet">
  <link href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.15.1/css/all.min.css" rel="stylesheet">
  <style>
    body, html {
      height: 100%;
      margin: 0;
      display: flex;
      flex-direction: column;
    }
    .header {
      background-color: #f8f9fa;
      z-index: 1020;
    }
    .chat-container {
      flex-grow: 1;
      overflow-y: auto;
      padding: 20px;
      display: flex;
      flex-direction: column-reverse;  /* New messages at the bottom */
    }
    .footer {
      background-color: #f8f9fa;
      z-index: 1020;
    }
    .message {
      width: 100%;
      padding: 5px 10px;
      box-sizing: border-box;
    }
    .user-message {
      text-align: right;
      background-color: #dcf8c6;
      border-radius: 8px 8px 0 8px;
    }
    .bot-message {
      text-align: left;
      background-color: #f0f0f0;
      border-radius: 8px 8px 8px 0;
    }
  </style>
</head>
<body>
  <div class="header p-3">
    <nav class="navbar navbar-expand-lg navbar-light bg-light">
      <a class="navbar-brand" target=_blank href="<?=$a['website']?>">
        <img src="logo.png" alt="Logo" style="width: 100px;">
      </a>
      <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbarNavAltMarkup" aria-controls="navbarNavAltMarkup" aria-expanded="false" aria-label="Toggle navigation">
        <span class="fas fa-bars"></span>
      </button>
      <div class="collapse navbar-collapse" id="navbarNavAltMarkup">
        <div class="navbar-nav ml-auto">
          <a class="nav-item nav-link" href="<?=$a['website']?>" target="_blank"><i class='fas fa-globe'></i>&nbsp;&nbsp;Website</a>
          <a class="nav-item nav-link" href="tel:<?=$a['phone']?>"><i class='fas fa-phone'></i>&nbsp;&nbsp;Call Me</a>
          <a class="nav-item nav-link" href="#"><i class='fas fa-door-open'></i>&nbsp;&nbsp;Exit Chat</a>
        </div>
      </div>
    </nav>
  </div>
  <div class="chat-container" id="chatContainer">
    <div id="messages"></div>
  </div>
  <div class="footer p-3">
    <div class="input-group">
      <input type="text" maxlength=256 id="chatInput" class="form-control" placeholder="Ask me anything..." autocomplete="off">
      <div class="input-group-append">
        <button class="btn btn-primary send-button" type="button" id="sendButton"><i class='fas fa-paper-plane'></i></button>
      </div>
    </div>
  </div>

  <script src="https://code.jquery.com/jquery-3.5.1.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
<?php 
  if ($a['showTyping'] == 'Y') {
    include "chatjs-typing.php";
  } else {
    include "chatjs.php";
  } 
?>
</body>
</html>