<div class="container">

<?php
  session_start(); if (!$_SESSION['user']) { die('not authorized'); }

  require_once "config.php";
  require_once "../adam/wrapper.php";

  loadAllCfg();
  tryConnect();

  $id = mysqli_real_escape_string($conn, @$_GET['id']);
  if ($id) {
    echo "<h1>Text extracted from ".htmlentities($id)."</h1>";
    echo nl2br(htmlentities(zbSQL("SELECT extractedText FROM audio WHERE `audio`='$id'")));
    exit;

  }

  $file = mysqli_real_escape_string($conn, @$_GET['file']);
  if ($file) {
    $result = transcribe($apiKey, "../audio/$file");
    if ($result) {
      $result = json_decode($result, true);
      if (@$result['error']) {
        echo "<pre>";
        print_r($result);
        echo "</pre>";
      }
      // error_log(print_r($result, true));
      $result = mysqli_real_escape_string($conn, $result['text']);
      $s = "UPDATE `audio` SET extractedText=\"$result\" WHERE `audio`='$file'";
      // error_log($s);
      $conn->query($s);
    } else {
      echo "<h1>Error during the transcription API</h1>";
    }
  }

  // Include SweetAlert JavaScript library
  echo '<script src="https://cdn.jsdelivr.net/npm/sweetalert2@11"></script>';
  
  $folderPath = '../audio'; // Specify the folder path
  
  // Scan the directory for files
  $files = scandir($folderPath);
  echo '<table class="table">';
  echo '<tr><th>Filename</th><th>Extracted Text</th><th>Pretty View</th></tr>';
  foreach ($files as $file) {
    if (preg_match('/\.(mp3|mp4)$/i', $file)) {
      $encodedFile = urlencode($file);
      $extractedText = '';
      
      // Prepare the SQL query
      $query = "SELECT extractedText FROM audio WHERE `audio`='" . mysqli_real_escape_string($conn, $file) . "'";
      $result = mysqli_query($conn, $query);
      if ($result && $row = mysqli_fetch_assoc($result)) {
        $extractedText = substr($row['extractedText'], 0, 250);
      }
  
      // Display the filename and extracted text
      echo '<tr>';
      echo "<td><a href='javascript:void(0);' onclick=\"confirmExtraction('$encodedFile', ".(strlen($extractedText)>3?'1':'null').")\">".htmlspecialchars($file)."</a></td>";
      echo '<td>' . htmlspecialchars($extractedText) . ' [...]</td>';
      echo '<td><a href="?pageid=userpages_speechtotext&id='.$encodedFile.'"> <i class="fa fa-eye"></i></a></td>';
      echo '</tr>';
    }
  }
  echo '</table>';
?>
  
  <script>
  function confirmExtraction(encodedFile, extractedText) {
    if (extractedText !== '') {
      Swal.fire({
        title: 'The text has already been extracted.',
        text: 'Are you sure you want to proceed and pay for it again?',
        icon: 'warning',
        showCancelButton: true,
        confirmButtonColor: '#3085d6',
        cancelButtonColor: '#d33',
        confirmButtonText: 'Yes, proceed!'
      }).then((result) => {
        if (result.isConfirmed) {
          window.location.href = '?pageid=userpages_speechtotext&file=' + encodedFile;
        }
      });
    } else {
      window.location.href = '?pageid=userpages_speechtotext&file=' + encodedFile;
    }
  }
  </script>
</div>